#include "Board.h"

Board::Board(Pinouts pinouts){
    lcd = new LCD(pinouts.lcd.rs, pinouts.lcd.e, pinouts.lcd.p4, pinouts.lcd.p5, pinouts.lcd.p6, pinouts.lcd.p7, LCD::LCD20x4);
    leds = new Leds(pinouts.leds.left, pinouts.leds.right);
    button = new Button(pinouts.button);
    key = new Key(pinouts.key);
    keyboard = new Keyboard(pinouts.keyboard);
    buzzer = new Buzzer(pinouts.buzzer);    
}

void Board::attach(ButtonListener *bl)
{
    listeners.push_back(bl);
}
void Board::buttonEvent(char c)
{
    for (int i = 0; i < listeners.size(); i++)
      listeners[i]->buttonEvent(c);
}