#ifndef BOARD_H
#define BOARD_H

#include "LCD.h" 
#include "Leds.h"
#include "Key.h"
#include "Buzzer.h"
#include "Button.h"
#include "Keyboard.h"

#include <vector>

// class for debug leds
// class for eeprom memory
// class for wireless (nordic chip or xbee)

struct Pinouts{
    PinName button;
    PinName key;
    LedPins leds;
    PinName buzzer;
    KeyboardPins keyboard;
    LcdPins lcd;
};

class ButtonListener
{
  public:
    virtual void buttonEvent(char c){
        
    };
};

class Board{
    public:
    Board(Pinouts pinouts);
    
    LCD* lcd;
    Leds* leds;
    Key* key;
    Button* button;
    Keyboard* keyboard;
    Buzzer* buzzer;
    
    vector < ButtonListener * > listeners;
    
    void attach(ButtonListener *bl);
    
    protected:
    void buttonEvent(char c);

    
};

#endif