#ifndef GAME_H
#define GAME_H

#include "../board/Board.h"

class Game : public ButtonListener{
    public:
    Game(Board* board);
    static const char* NAME;
    
    virtual void setup() = 0;
    virtual void run() = 0;
    
    Board* getBoard();
    
    protected:
    Board* board;
    
    LCD* lcd;
    Leds* leds;
    Key* key;
    Button* button;
    Keyboard* keyboard;
    Buzzer* buzzer;
    
    void init();
    void end();
    
};


#endif