#ifndef OBJECTIVE_H
#define OBJECTIVE_H

#include "../games/Game.h"

class Objective : public ButtonListener{
    
    enum Status { WAITING, ACTIVE, COMPLETED };
    
    public:
    Objective(Game* game);
    Status getStatus();
    
    void start();
    virtual void run() = 0;
    void complete();
    
    protected:
    Game* game;
    
    LCD* lcd;
    Leds* leds;
    Key* key;
    Button* button;
    Keyboard* keyboard;
    Buzzer* buzzer;
       
    private:
    Status status;
    
};


#endif